/////////////////////////////////////////////////////////////
//
// BIBDAN.JS
// Bibliothque de composants JavaScript rutilisables
// Auteur: Daniel ODDON (http://www.chez.com/oddon/)
// Version 1.0 du xx dcembre 1997
//
/////////////////////////////////////////////////////////////

//////////////// Objets ////////////////

//Pour retour de plusieurs lments par une fonction
function u_message() {this.chaine=null;this.entier=null;this.decimal=null;this.objet=null;}

function u_tableau() {
  this.length = u_tableau.arguments.length;
  for (var i = 0; i < this.length; i++);  
    this[i+1] = u_tableau.arguments[i];
}

//unTableau= new u_tableau(17, 3, 5);

//////////////// Variables globales ////////////////

g_uo_message=new u_message(); //Pour retour de paramtres combins
g_CRLF='\r\n'; //Personnaliser suivant la plateforme

/////////// Fonctions gnrales /////////////////////////////
//
// String f_remplacer(p_texte,p_rechercher,p_remplacer,p_debut) //Positionne g_uo_message.entier
// String f_remplacerPartout(p_texte,p_rechercher,p_remplacer) //Positionne g_uo_message.entier
// String f_remplacerPlus(p_texte,p_rechercher,p_remplacer,p_debut) //Positionne g_uo_message.entier, et g_uo_message.chaine (astrisque)
// String f_remplacerPartoutPlus(p_texte,p_rechercher,p_remplacer) //Positionne g_uo_message.entier
// String f_extraire(p_chaine,p_numero,p_delimiteur,p_debut) 
// String f_2unix(p_texte) //LF
// String f_2pc(p_texte) //CRLF
// String f_2mac(p_texte) //CR
// String f_2g_CRLF(p_texte) //retours charriots suivant plate-forme d'excution
// String f_bd2html(p_texte) //Transforme une table avec sparateur tabulation en table HTML
// String f_html2bd(p_texte) //Transforme une table HTML en table avec sparateur tabulation
// String f_proprietes(p_uo_obj, p_s_nomObj)
// Void   function f_afficherHTML(p_html) //Ouvre une fentre avec le HTML pass en paramtre
//
/////////////////////////////////////////////////////////////


function f_remplacer(p_texte,p_rechercher,p_remplacer,p_debut) {
	if (p_debut >= p_texte.length) {g_uo_message.entier=-1; return p_texte;}
	var i_position=p_texte.indexOf(p_rechercher,p_debut);
	if (i_position == -1) {g_uo_message.entier=-1; return p_texte;}
	var moitie1 = p_texte.substring(0,i_position);
	var moitie2 = p_texte.substring(i_position + p_rechercher.length,p_texte.length);
	var retour =  moitie1 + p_remplacer + moitie2;	
	g_uo_message.entier = i_position+p_remplacer.length; //1er caractre suivant
	return retour;
}


function f_remplacerPartout(p_texte,p_rechercher,p_remplacer) {
	var compteur=0;
	var texte=f_remplacer(p_texte,p_rechercher,p_remplacer,0);
	while (g_uo_message.entier >= 0 ) {
		compteur++;
		texte=f_remplacer(texte,p_rechercher,p_remplacer,g_uo_message.entier);
	}
	g_uo_message.entier=compteur; //Nb d'occurences
	return texte;
}

function f_remplacerPartoutPlus(p_texte,p_rechercher,p_remplacer) {
	var compteur=0;
	var texte=f_remplacerPlus(p_texte,p_rechercher,p_remplacer,0);
	while (g_uo_message.entier >= 0 ) {
		compteur++;
		texte=f_remplacerPlus(texte,p_rechercher,p_remplacer,g_uo_message.entier);
	}
	g_uo_message.entier=compteur; //Nb d'occurences
	return texte;
}

//Marche pour l'instant avec une seule astrisque utilisable aussi dans p_remplacer
//On peut accder  cette valeur (astrisque) par g_uo_message.chaine
function f_remplacerPlus(p_texte,p_rechercher,p_remplacer,p_debut) {
	var p_rech1,p_rech2,pos1,pos2,s_remplacer;
	p_rech1=f_extraire(p_rechercher,1,'*',0);
	p_rech2=f_extraire(p_rechercher,2,'*',0);
	if (p_rech1==null || p_rech2==null) 
		return f_remplacer(p_texte,p_rechercher,p_remplacer,p_debut); //Pas d'astrisque
	pos1=p_texte.indexOf(p_rech1,p_debut);
	if (p_rech2=='')
		pos2=p_texte.length; // '*'  la fin de p_rechercher
	else
		pos2=p_texte.indexOf(p_rech2,pos1+p_rech1.length);
	if (pos1==-1 || pos2==-1) {g_uo_message.entier=-1; return p_texte;} //Pas trouv
	if (p_rech1=='') pos1=0; // '*' au dbut de p_rechercher
	else pos1=p_texte.lastIndexOf(p_rech1,pos2 - 1); //Astuce pour pour minimiser la taille de 'astrisque'
	g_uo_message.chaine=p_texte.substring(pos1+p_rech1.length,pos2);

	s_remplacer=f_remplacerPartout(p_remplacer,'*',g_uo_message.chaine);
	return f_remplacer(p_texte,p_rech1+g_uo_message.chaine+p_rech2,s_remplacer,p_debut);
}


function f_extraire(p_chaine,p_numero,p_delimiteur,p_debut) {
//Code retour NULL = invalide
//extraire("Daniel;Oddon;Salut",2,";",0)="Oddon"
//extraire("Daniel;Oddon;",3,";",0)=""
//extraire("Daniel;Oddon",3,";",0)=null
//extraire("Daniel;Oddon;",1,";",8)="Oddon"

var position1,position2,tampon,tailleDelimiteur;

if (p_numero<1) return null;

tailleDelimiteur=p_delimiteur.length;
position1=p_debut

for (var i=1 ; i< p_numero ;i++) {
	tampon=p_chaine.indexOf(p_delimiteur,position1);
	if (tampon==-1) return null; //Champ demand inexistant
	position1=tampon+tailleDelimiteur; //1er caractre aprs le dlimiteur
}
if (position1>p_chaine.length) return ''; //Chane finissant par dlimiteur
position2=p_chaine.indexOf(p_delimiteur,position1);
if (position2==-1) position2=p_chaine.length ;//Cas o l'on demande le dernier champ
return p_chaine.substring(position1,position2);
}


function f_2unix(p_texte)
{
var retour=p_texte;
retour=f_remplacerPartout(retour,'\r\n','\n'); // PC -> Unix
retour=f_remplacerPartout(retour,'\r','\n'); // Mac -> Unix
return retour;
}

function f_2mac(p_texte)
{
var texte=p_texte;
texte=f_remplacerPartout(texte,'\r\n','\r'); // PC -> Mac
texte=f_remplacerPartout(texte,'\n','\r'); // Unix -> Mac
return texte;
}

function f_2pc(p_texte)
{
var texte=p_texte;
texte=f_remplacerPartout(texte,'\r\n','__CRLF__'); // PC -> Temp (permet non altration si dj PC)
texte=f_remplacerPartout(texte,'\n','__CRLF__'); // Unix -> Temp
texte=f_remplacerPartout(texte,'\r','__CRLF__'); // Mac -> Temp
texte=f_remplacerPartout(texte,'__CRLF__','\r\n'); // Temp -> PC
return texte;
}

function f_2g_CRLF(p_texte)
{
var texte=p_texte;
texte=f_remplacerPartout(texte,'\r\n','__CRLF__'); // PC -> Temp (permet non altration si dj PC)
texte=f_remplacerPartout(texte,'\n','__CRLF__'); // Unix -> Temp
texte=f_remplacerPartout(texte,'\r','__CRLF__'); // Mac -> Temp
texte=f_remplacerPartout(texte,'__CRLF__',g_CRLF); // Temp -> g_CRLF retour charriot de la plateforme.
return texte;
}


function f_bd2html(p_texte,p_colonne,p_ligne)
{
var texte=p_texte;
texte='<TABLE BORDER=1><CAPTION>'+g_CRLF+texte; //Entte
texte=f_remplacerPartout(texte,'\t','<TD>'); 
texte=f_remplacerPartout(texte,g_CRLF,g_CRLF+'<TR><TD>');
texte=texte+g_CRLF+'</TABLE>'; //Fin
return texte;
}


function f_html2bd(p_texte)
{
var texte=p_texte;
texte=f_remplacerPartoutPlus(texte,'<TD*>','\t');
texte=f_remplacerPartoutPlus(texte,'<TR*>','<TR>');
texte=f_remplacerPartoutPlus(texte,'<TR>*\t',''); //On efface d'eventuels CRLF entre <TR> et <TD>
texte=f_remplacerPartoutPlus(texte,'<*>','');
//texte=f_remplacerPlus(texte,'*'+g_CRLF,'',0) //Suppression de la ligne <TABLE>
return texte;
}




// Afficheur multi-objets
function f_proprietes(p_uo_obj, p_s_nomObj) {
	var s_result = '';
	for (var i in p_uo_obj)
		s_result += p_s_nomObj + "." + i + " = " + p_uo_obj[i] + "\n";
	return s_result;
}


function f_afficherHTML(p_html)
{
var w_affichage=window.open("","","status=yes,resizable=yes,menubar=yes,scrollbars=yes");
w_affichage.document.write(p_html);
w_affichage.document.close();
}


//Marche pas avec NN
var w_ini
function f_ini(p_fichier)
{
var ls_retour
w_ini=window.open(p_fichier,"","width=1,height=1,status=no,resizable=no,menubar=no,scrollbars=no");
//if (w_ini.opener==null) w_ini.opener=window;
ls_retour=w_ini.document.forms[0].elements[0].value;
w_ini.close();
return ls_retour;
}


